/*
Provides input producing numbers between set ranges.  Uses clock time elapsed since power up as srand.  
J. Hearon 5/22/1990
J. Hearon 9/1/2011
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>
#include <math.h>

int randRange_arcsine(int n)
{
    int top = ((((RAND_MAX-n)+1)/n)*n-1)+n;
    int r;
    do
    {
        r = rand();
    }
    while (r>top);
    return r%n;
}

int *arcsineinput(int *arcsinereturnarray)
{
    int *s = arcsinereturnarray;
    int t, l, n, h, x, f;
    double r, u;
    float d;
    int rand(void);

    struct timeval  t1;

    printf("\t\t\tARCSINE DISTRIBUTION\n");
    printf("\t\t\t***** PITCHES *****");
    printf("\n");

//***************************************
//********  USER INTERFACE **************
//***************************************
first:
    s=(int*)calloc(1000,sizeof(int));/*pointer 's' is allocated 1000 integers and treated like an array */

    printf("\n");
    printf("How many pitches? (500 MAX):");
    scanf("%d",&t);

    d=0;/* sets value of 'd' initially to 0 */
start:
    printf("\nEnter lowest midi note value for a pitch:");
    scanf("%d", &l);
    printf("\nEnter highest midi note value for a pitch:");
    scanf("%d", &h);
    printf("\n");
    if(h-1<=1) /*loop placed here as a precaution*/
    {
        goto start;
    }
    h=h+1;/* highest no. gets plus one */

//***************************************
//********  MAIN ARCSINE LOOP ***********
//***************************************
    for (x=1; x<=t; x++)
    {
next:
        gettimeofday(&t1, NULL);
        srand(t1.tv_usec * t1.tv_sec);

        r = ((double)rand()/((double)(RAND_MAX)+(double)(1))); /*scales value of 'r' to 0..1 */
        r = r + randRange_arcsine(2); //makes 'top' of the range 1.  Thus 0 > r < 2.
        //adjust top when RAND_MAX will not allow random selections
        //in the algorithms below.
        //printf(" %4.6f ", r); //DEBUG

        u=pow(sin(3.1459*(double)r/(double)2),2); //arcsine dist
        f=(int)(u*h-1)+1; //limits between ranges
        if(f<l || f>h-1)  /*avoid out of bounds nums */
        {
            goto next;
        }
        s[x]= f;
    } //end for loop

    printf("\n...from arcsine.cpp\n");
    for (x=1; x<=t; x++)
    {
        printf("%4d",s[x]);/*prints numbers */
    }
    printf("\n\n");

//****************************************
//********  User Switch to Try Again *****
//****************************************
    printf("\ntry again? 1 for yes, 2 for no: ");
    scanf("%d", &n);
    switch (n)
    {
        //case 1: goto start;
    case 1:
        free(s);
        goto first;
        break;
    case 2:
        printf("\nbye");
        break;
    }//ends switch
    printf("\n");


    return s;

} //ends arcsineinput


