/*
Randomizes (arcsine) a 2d array of float values 
as rhythms for the preprocessor cscore2.c file
J. Hearon 9/1/2011
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <sys/time.h>
#include <time.h>
#include <errno.h>

#define ASTRUCT_MAXROWS 1
#define ASTRUCT_MAXCOLS 1

struct the2dstruct
{
    int structnum;
    int nrows;
    int ncols;
    float a2dstruct[ASTRUCT_MAXROWS][ASTRUCT_MAXCOLS];
};


int randRange_ran2dstructs(int n)
{
    int top = ((((RAND_MAX-n)+1)/n)*n-1)+n;
    int r;
    do
    {
        r = rand();
    }
    while (r>top);
    return r%n;
}

float *random2dstructs(int inrows, int incols, float **input2darray, int returnrows, int returncols)
{
    int spinrows = returnrows;
    int spincols = returncols;
    int spincount = returnrows * returncols;
    int hh = inrows * incols;
    int h; //highest number
    int l = 1; //lowest number
    int f, i, j, k, n, x, y, oddnumrange;
    int rand(void);
    double r, u;
    float **s = NULL;  //the local 2d array
    float *sPool, *curS_Ptr; //for calloc
    float *ss = NULL;//local 1d arrays
    int *t = NULL;
    int *tt = NULL;

    struct the2dstruct **Arrayof2dStructs = NULL;
    struct timeval  t1; //structs for rand using time

first:
//*****************************************
//********  ALLOCATE MEMORY ***************
//*****************************************
//allocate local initialized 2d array memory
//NOTE: use of ptr pool for ease of freeing arrays later in the func
    s=(float **) calloc(spinrows+1, sizeof(float*));
    sPool = (float*)calloc(spincols*spinrows,sizeof(float));
    curS_Ptr=sPool;
    for (i = 0; i<spinrows+1; i++)
    {
        s[i]= curS_Ptr;
        curS_Ptr += spincols;
    }

//allocate local initialized 1d array memory
    ss=(float *) calloc(spincount, sizeof(float*));
    t=(int *) calloc(spincount, sizeof(int*));
    tt=(int *) calloc(spincount, sizeof(int*));

//allocate memory for one 2d struct
    Arrayof2dStructs = (struct the2dstruct *)calloc(1, sizeof(struct the2dstruct));
    h= inrows*incols;
    for (x=0; x<=h; x++)
    {
        /* add ONE element to the array */
        Arrayof2dStructs= (struct the2dstruct **)realloc(Arrayof2dStructs, (x + 1) * sizeof(struct the2dstruct *));
        /* allocate memory for x number of the2dstructs */
        Arrayof2dStructs[x] = (struct the2dstruct *)malloc(sizeof(struct the2dstruct));
    }

//load data from incoming 2d array to local array of structs
//structnums begin with '1' for ease of counting and printing,
//but structs begin with '0'
    x=0;
    y=1;
    for (j = 0; j<inrows; j++)
    {
        for (k = 0; k<incols; k++)
        {
            Arrayof2dStructs[x]->a2dstruct[0][0] = input2darray[j][k];
            Arrayof2dStructs[y]->structnum = y;
            x++;
            y++;
        }
    }

//load only the odd numbers into a local 1d array
    oddnumrange=1;
    for (x=1; x<=hh; x++)
    {
        if(x%2==1)
        {
            t[oddnumrange] = x;
            oddnumrange++;
        }
    }


//*****************************************************************
//********  RANDOMIZE array of structures (arcsine) ***************
//*****************************************************************

    h=oddnumrange;  //highest equals the number of values + 1 (from oddnumrange++ above)
    for (x=1; x<=spincount/2; x++)
    {
next:
        gettimeofday(&t1, NULL);
        srand(t1.tv_usec * t1.tv_sec);

        r = ((double)rand()/((double)(RAND_MAX)+(double)(1))); /*scales value of 'r' to 0..1 */
        r = r + randRange_ran2dstructs(2); //makes 'top' of the range 1.  Thus 0 > r < 2.
        //adjust top when RAND_MAX will not allow random selections
        //in the algorithms below.
        //printf(" %4.6f ", r); //DEBUG

        u=pow(sin(3.1459*(double)r/(double)2),2); //arcsine distribution
        f=(int)(u*h-1)+1; //limits between ranges
        if(h==1)   //avoids rare case where highest = 1
        {
            if(f<l || f>h)
            {
                goto next;
            }
        }
        else
        {
            if(f<l || f>h-1)  /*avoid out of bounds nums */
            {
                goto next;
            }
        }

        tt[x]= t[f];
    } //end for loop

// Fill odd slots
// uses the randomized numbers, from above
    x=0;
    for(i=1; i<=spincount/2; i++)
    {
        n=tt[i];
        x=x+1;
        ss[x]= Arrayof2dStructs[n-1]->a2dstruct[0][0];
        x++;
    }

// Fill even slots with the even pair
    x=2;
    for(i=1; i<=spincount/2; i++)
    {
        n=tt[i];
        ss[x]=Arrayof2dStructs[n]->a2dstruct[0][0];
        x=x+2;
    }


// loads the 1d array into a 2d array to return to the
// RHY2DINPUT func below
    printf("...printing the spincount of 2d spun structs (from rand2dstructs)...\n");
    i=0;
    for (j = 0; j<spinrows; j++)
    {
        for (k = 0; k<spincols; k++)
        {
            i++;
            s[j][k] = ss[i];
            printf("%d: %4.6f\n", i, s[j][k]);
        }
    }

//switch here to do another spin before returning values
    printf("\ntry again? 1 for yes, 2 for no: ");
    scanf("%d", &y);
    switch (y)
    {
    case 1:
        for (x=0; x<=h; x++)
        {
            free(Arrayof2dStructs[x]);
        }
        free (Arrayof2dStructs);
        free(*s);
        free(s);
        free(ss);
        free(t);
        free(tt);
        goto first;
        break;
    case 2:
        printf("\nbye");
        break;
    }//ends switch
    printf("\n");

    for (x=0; x<=h; x++)
    {
        free(Arrayof2dStructs[x]);
    }
    free (Arrayof2dStructs);
    free(ss);
    free(t);
    free(tt);

    return s; //return only the local 2d array of randomized nums
    //not the whole struct to RHY2DINPUT, below

} //end random2dstructs

//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++

//******   RHY2DINPUT    ******

//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++

float *rhy2Dinput(float *rhy2Dreturnarray)
{
    float **struct2dinputarray = NULL; //local 2d arrays
    float **struct2dreturnarray = NULL;
    float  *struct1dreturnarray = NULL;//local 1d array
    int i, j, k, n, x;
    int rows, spinrows;  //number of input pairs and returned pairs
    int cols = 2;  //one input pair (for 2d leave cols as "2")
    int spincols = 2; //one returned pair
    float *inputPool, *returnPool; //for calloc
    float *curInputPtr, *curReturnPtr; //for calloc

//**************************************
//********  ENTER VALUES ***************
//**************************************


//fill a 2d array to send to random2dstructs function, above
start:
    printf("\n");
    printf("Enter the number of pairs: ");
    scanf("%d",&rows);

//allocate 2d array memory
//keep 2d array as 2 cols
//But rows * num of pairs are needed for input
//NOTE: use of ptr pool for ease of freeing arrays later in the func
    struct2dinputarray=(float **) calloc(rows, sizeof(float*));
    inputPool = (float*)calloc(cols*rows,sizeof(float));
    curInputPtr=inputPool;
    for (i = 0; i<rows; i++)
    {
        struct2dinputarray[i]= curInputPtr;
        curInputPtr += cols;
    }
//load the 2d array with rhythmic pairs, ex:
//(0,0)=1.5, (0,,1)=0.5
//(1,0)=0.75, (1,1)=0.25, etc.
    x=1;
    for (j = 0; j<rows; j++)
    {
        for (k = 0; k<cols; k++)
        {
            printf("Enter value #%d: ", x);
            scanf("%f",&struct2dinputarray [j][k]);
            x++;
        }
    }

    printf("\n...here's the list \n");
    for (j = 0; j<rows; j++)
    {
        for (k = 0; k<cols; k++)
        {
            printf("%2.4f\n",  struct2dinputarray[j][k]);
        }
    }

//switch for another spin before returning values
    printf("\ntry again? 1 for yes, 2 for no: ");
    scanf("%d", &n);
    switch (n)
    {
    case 1:
//free 2d array memory
//NOTE: this how ptr pool helps with freeing memory
        free(*struct2dinputarray);
        free(struct2dinputarray);
        goto start;
        break;
    case 2:
        goto next;
        break;
    }//ends switch
    printf("\n");
//***************************************
//********  RETURN VALUES ***************
//***************************************
next:
//number of pairs to be returned
    printf("\nEnter the number of pairs to be returned: ");
    scanf("%d",&spinrows);

//allocate 1d array memory
    struct1dreturnarray=(float **) calloc((spinrows*spincols), sizeof(float*));

//allocate 2d array memory
//NOTE: use of ptr pool for ease of freeing arrays later in the func
    struct2dreturnarray=(float **) calloc(spinrows, sizeof(float*));
    returnPool = (float*)calloc(spincols*spinrows,sizeof(float));
    curReturnPtr = returnPool;
    for (i = 0; i<spinrows; i++)
    {
        struct2dreturnarray[i]= curReturnPtr;
        curReturnPtr += spincols;
    }

    struct2dreturnarray = random2dstructs(rows, cols, struct2dinputarray, spinrows, spincols);


// convert the 2d array from random2dstructs function to a 1d array
// to RETURN to main, for use with Cscore
    x=0;
    for (j = 0; j<spinrows; j++)
    {
        for (k = 0; k<spincols; k++)
        {
            x++;
            struct1dreturnarray[x] = struct2dreturnarray[j][k];
        }
    }

//free 2d array memory
//NOTE: this how ptr pool helps with freeing memory
    free(*struct2dinputarray);
    free(struct2dinputarray);

    free(*struct2dreturnarray);
    free(struct2dreturnarray);

    return struct1dreturnarray;   //returns a 1d array of rhythms

} //end rhy2dinput

